//Copyright 2013 Michael Leitner, distributed as free softtware,
//see COPYING for more details

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "litdb.h"

//löscht eintrag ind aus liste

void delete_from_dump(int * Np,int * idx,char * dump,int ind) {
	int i,m;
	
	memmove(dump+idx[ind],dump+idx[ind+1],idx[*Np]-idx[ind+1]);
	m=idx[ind+1]-idx[ind];
	for (i=ind;i<*Np;i++) idx[i]=idx[i+1]-m;
	--*Np;
}

//zeigt units für gegebene kombination von tags an oder tags einer unit

int main(int argc,char *argv[]) {
	struct database db;
	int i,uind,tind,v,m;
	
	read_db(&db);
	
	if ((argc==3)&&(strcmp(argv[1],"-u")==0)) {
		uind=find_string(argv[2],db.Nunit,db.units,db.unitdump,&v);
		if (v==0) {
			printf("%s does not exist!\n",argv[2]);
			return 2;
		}
		for (tind=0;tind<db.Ntag;tind++) if (db.colhead[tind]<db.colhead[tind+1]) {
			m=bisect(db.tidx,db.colhead[tind],db.colhead[tind+1],uind);
			if (db.tidx[m]==uind) {
				memmove(db.tidx+m,db.tidx+m+1,(db.colhead[db.Ntag]-m-1)*sizeof(short int));
				for (i=tind+1;i<=db.Ntag;i++) --db.colhead[i];
			}
		}
		delete_from_dump(&(db.Nunit),db.units,db.unitdump,uind);
		//tidx anpassen
		for (i=0;i<db.colhead[db.Ntag];i++) if (db.tidx[i]>uind) --db.tidx[i];
	} else if ((argc==3)&&(strcmp(argv[1],"-t")==0)) {
		tind=find_string(argv[2],db.Ntag,db.tags,db.tagdump,&v);
		if (v==0) {
			printf("%s does not exist!\n",argv[3]);
			return 2;
		}
		memmove(db.tidx+db.colhead[tind],db.tidx+db.colhead[tind+1],(db.colhead[db.Ntag]-db.colhead[tind+1])*sizeof(short int));
		m=db.colhead[tind+1]-db.colhead[tind];
		for (i=tind;i<db.Ntag;i++) db.colhead[i]=db.colhead[i+1]-m;
		delete_from_dump(&(db.Ntag),db.tags,db.tagdump,tind);
	} else if ((argc==4)&&(strcmp(argv[1],"-e")==0)) {
		uind=find_string(argv[2],db.Nunit,db.units,db.unitdump,&v);
		if (v==0) {
			printf("%s does not exist!\n",argv[2]);
			return 2;
		}
		tind=find_string(argv[3],db.Ntag,db.tags,db.tagdump,&v);
		if (v==0) {
			printf("%s does not exist!\n",argv[3]);
			return 2;
		}
		if (db.colhead[tind]<db.colhead[tind+1]) {
			m=bisect(db.tidx,db.colhead[tind],db.colhead[tind+1],uind);
			if (db.tidx[m]==uind) {
				memmove(db.tidx+m,db.tidx+m+1,(db.colhead[db.Ntag]-m-1)*sizeof(short int));
				for (i=tind+1;i<=db.Ntag;i++) --db.colhead[i];
			}
		}
	} else {
		printf("Usage: delete_db -e UNIT TAG\n  or   delete_db -t TAG\n  or   delete_db -u UNIT\nDelete single entries or a given tag/unit along with all corresponding entries from the database.\n");
		return 1;
	}
		
	write_db(&db);
}
