//Copyright 2013 Michael Leitner, distributed as free softtware,
//see COPYING for more details

#include <stdlib.h>
#include <stdio.h>
#include "litdb.h"

void read_db(struct database * dbp) {
	struct database db;
	int i;

	FILE * dbfile=fopen(DATABASE_NAME,"rb");
	if (dbfile==NULL) {
		db.Nunit=0;
		db.Ntag=0;
		
		db.units=calloc(sizeof(int),1);
		db.tags=calloc(sizeof(int),1);
		
		db.unitdump=NULL;
		db.tagdump=NULL;
		
		db.colhead=calloc(sizeof(int),1);
		db.tidx=NULL;
	} else {
		fread(&(db.Nunit),sizeof(int),1,dbfile);
		fread(&(db.Ntag),sizeof(int),1,dbfile);
	
		db.units=malloc(sizeof(int)*(db.Nunit+1));
		fread(db.units,sizeof(int),db.Nunit+1,dbfile);
		db.tags=malloc(sizeof(int)*(db.Ntag+1));
		fread(db.tags,sizeof(int),db.Ntag+1,dbfile);
	
		i=db.units[db.Nunit];
		db.unitdump=malloc(sizeof(char)*i);
		fread(db.unitdump,sizeof(char),i,dbfile);
		i=db.tags[db.Ntag];
		db.tagdump=malloc(sizeof(char)*i);
		fread(db.tagdump,sizeof(char),i,dbfile);	
	
		db.colhead=malloc(sizeof(int)*(db.Ntag+1));
		fread(db.colhead,sizeof(int),db.Ntag+1,dbfile);
		db.tidx=malloc(sizeof(short int)*(db.colhead[db.Ntag]));
		fread(db.tidx,sizeof(short int),db.colhead[db.Ntag],dbfile);
	
		fclose(dbfile);
	}
	
	*dbp=db;
}

void write_db(struct database * dbp) {
	struct database db=*dbp;
	
	FILE * dbfile=fopen(DATABASE_NAME,"wb");
	fwrite(&(db.Nunit),sizeof(int),1,dbfile);
	fwrite(&(db.Ntag),sizeof(int),1,dbfile);
	
	fwrite(db.units,sizeof(int),db.Nunit+1,dbfile);
	fwrite(db.tags,sizeof(int),db.Ntag+1,dbfile);
	
	fwrite(db.unitdump,sizeof(char),db.units[db.Nunit],dbfile);
	fwrite(db.tagdump,sizeof(char),db.tags[db.Ntag],dbfile);
	
	fwrite(db.colhead,sizeof(int),db.Ntag+1,dbfile);
	fwrite(db.tidx,sizeof(short int),db.colhead[db.Ntag],dbfile);	
	
	fclose(dbfile);
}
